package net.wanji.opt.servicev2.judgeanalysis.impl;

import net.wanji.opt.entity.judgeanalysis.AnalysisProblemCrossDay;
import net.wanji.opt.dao.mapper.judgeanalysis.AnalysisProblemCrossDayMapper;
import net.wanji.opt.entity.judgeanalysis.CrossPoint;
import net.wanji.opt.servicev2.judgeanalysis.AnalysisProblemCrossDayService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import javax.annotation.Resource;
import java.util.List;
import org.locationtech.jts.geom.Geometry;

/**
* <p>
* 路口问题分析 服务实现类
* </p>
*
* @author fengyi
* @since 2025-03-13
*/
@Service
 public class AnalysisProblemCrossDayServiceImpl extends ServiceImpl<AnalysisProblemCrossDayMapper, AnalysisProblemCrossDay> implements AnalysisProblemCrossDayService {

	 @Resource
	 private AnalysisProblemCrossDayMapper analysisProblemCrossDayMapper;

	
	 /**
	 * 路口问题分析详情
	 * @param id
	 * @return
	 */
	 @Override
	 public AnalysisProblemCrossDay info(Long id) {
	
	 	return getById(id);
	 }
	
	 /**
	 * 路口问题分析新增
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void add(AnalysisProblemCrossDay param) {
	
	 	save(param);
	 }
	
	 /**
	 * 路口问题分析修改
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void modify(AnalysisProblemCrossDay param) {
	
	 	updateById(param);
	 }
	
	 /**
	 * 路口问题分析删除(单个条目)
	 * @param id
	 * @return
	 */
	 @Override
	 public void remove(Long id) {
	 	removeById(id);
	 }
	
	 /**
	 * 路口问题分析删除(多个条目)
	 * @param ids
	 * @return
	 */
	 @Override
	 public void removes(List<Long> ids) {
	
	 	removeByIds(ids);
	 }

	/**
	 * 路口区域id数据添加
	 * @return
	 */
	@Override
	public void updateCrossAreaIdByCondition() {
		//判断路口的areaId是否存在
		List<CrossPoint> crossPoints = analysisProblemCrossDayMapper.findCrossPoint();
		if(crossPoints.size()>0)
		{
			//获取区域id的坐标范围
			List<CrossPoint> areaPont = analysisProblemCrossDayMapper.findAreaPoint();
			//循环判断是否存在区域内
			for(CrossPoint crossPoint:crossPoints){
				int i = 0;
				for(CrossPoint areaPoint:areaPont){
				    String a =	crossPoint.getPoint().replaceAll( " ",",");
					Geometry geo = net.wanji.common.gts.GeomsConvertUtil.createPoint(a);
					Geometry geo1 = net.wanji.common.gts.GeomsConvertUtil.genGeometry(areaPoint.getPoint());
					if(geo.within(geo1)){
						//如果匹配则更新id
						analysisProblemCrossDayMapper.updateCrossAreaIdByid(areaPoint.getId(),crossPoint.getId());
						i = 1;
					}
				}
				if(i==0){
					//未匹配则把区域id设置为0
					analysisProblemCrossDayMapper.updateCrossAreaIdByid("0",crossPoint.getId());
				}
			}
		}

	}



}
